function notification_simulation(){
local title="${2}"
local text="${1}"
local author="${3}"
if test "$(pm list package | grep -w 'com.google.android.ext.services' )" != "" ;then
	cmd notification allow_assistant 'com.google.android.ext.services/android.ext.services.notification.Assistant'
fi
#local word_count="`echo "${text}" | wc -c`"
#test "${word_count}" -gt "375" && text='文字超出限制，请尽量控制在375个字符！'
	test -z "${title}" && title='10007'
		test -z "${text}" && text='您未给出任何信息'
	test "`echo "${author}" | grep -E '^[0-9].*[0-9]$'`" = "" && author="2000"
su -lp "${author}" -c "cmd notification post -S messaging --conversation '${title}' --message '${title}':'${text}' 'Tag' '$(echo $RANDOM)' " >/dev/null 2>&1
}

function Host_info(){
local MODPATH="${0%/*}"
local host_file=`find "${MODPATH}" -iname "hosts" -type f | head -n 1`
test "${host_file}" = "" && host_file="/system/etc/hosts"
local host_count="$(cat $host_file | sed '/^#/d;/^[[:space:]]*$/d' | wc -l)"
if test "$host_count" -ge "500000" ;then 
	local sate="网络存在一定延迟"
elif test "$host_count" -ge "50000" ;then 
	local sate="网络小幅度延迟"
elif test "$host_count" -lt "50000" ;then 
	local sate="网络基本无影响"
fi
echo "当前Host数量: ${host_count}，${sate}"
#echo "${host_count}"
}

function reset_modules(){
test -f "${0%/*}/module.prop" && return 0
cat << KEY > "${0%/*}/module.prop"
id=GGAT_10007
name=去广告
version=橴炫v184
versionCode=185
author=@coolapk 10007
description=host+chattr+pm+iptables去广告，host规则来自网络+本人手动抓取。$(Host_info)
updateJson=https://lingeringsound.github.io/10007/update.json
KEY
}

test ! -f "${0%/*}/backup.prop" && cp -rf "${0%/*}/module.prop" "${0%/*}/backup.prop"

flag_file="${0%/*}/xiaomi_backup"

if test ! -f "${flag_file}" ;then
	iptables -A OUTPUT -m string --string "a0.app.xiaomi.com" --algo bm --to 65535 -j DROP
	touch "${flag_file}"
	notification_simulation "已经放行a0.app.xiaomi.com，注意放行可能会泄露已安装应用给小米，风险自行承担。" "放行MIUI云备份" "去广告模块"
	sed -i 's/description=.*/description=☞当前以放行MIUI云备份，注意放行a0.app.xiaomi.com，可能会泄露已安装应用给小米。☜\n/g' "${0%/*}/module.prop"
else
	iptables -D OUTPUT -m string --string "a0.app.xiaomi.com" --algo bm --to 65535 -j DROP
	rm -rf "${flag_file}"
	notification_simulation "已禁止访问a0.app.xiaomi.com，保护您的安全。" "禁用MIUI云备份" "去广告模块"
	cp -rf "${0%/*}/backup.prop" "${0%/*}/module.prop"
fi

reset_modules











